﻿Imports System.Text.RegularExpressions

Public Class passwordMeter
    Inherits Label

    Private StrengthRatings() As String = {"Extremely weak", "Very Weak", "Weak", "Medium", "Strong", "Very Strong"}
    Private associatedEditControl As TextBox
    Private password As String

    Private _score As Integer = 0
    Public Property score() As Integer
        Get
            Return _score
        End Get
        Set(ByVal value As Integer)
            _score = value
            'repaint control
            MyBase.Invalidate()
        End Set
    End Property

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        If score > 0 Then
            e.Graphics.FillRectangle(New SolidBrush(GetColor(score)), New Rectangle(0, 0, score * 2, MyBase.ClientSize.Height))
        End If
        MyBase.OnPaint(e)
    End Sub

    Private Function GetColor(ByVal score As Integer) As Color
        Select Case score
            Case 0
                Return Color.FromArgb(220, 150, 150)
            Case 10
                Return Color.FromArgb(230, 185, 185)
            Case 20
                Return Color.FromArgb(200, 190, 220)
            Case 30
                Return Color.FromArgb(235, 240, 220)
            Case 40
                Return Color.FromArgb(215, 230, 190)
            Case 50
                Return Color.FromArgb(195, 215, 155)
        End Select
    End Function

    'setup handler
    Public Sub bindTextbox(ByVal tb As TextBox)
        associatedEditControl = tb
        AddHandler associatedEditControl.KeyUp, AddressOf tb_KeyUp
    End Sub

    Private Sub tb_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        password = associatedEditControl.Text
        CalculateMeter()
    End Sub

    Sub CalculateMeter()
        Dim passwordScore As Integer = 50

        'Length more than 8?
        If (password.Length < 8) Then passwordScore -= 10

        'all lower case?
        If Regex.IsMatch(password, "^[a-z]+$") Then
            passwordScore -= 10
        End If

        'all upper case?
        If Regex.IsMatch(password, "^[A-Z]+$") Then
            passwordScore -= 10
        End If

        'all digits?
        If Regex.IsMatch(password, "^\d+$") Then
            passwordScore -= 10
        End If

        'contains digit?
        If Not Regex.IsMatch(password, "\d") Then
            passwordScore -= 10
        End If

        'contains lower case char?
        If Not Regex.IsMatch(password, "[a-z]") Then
            passwordScore -= 10
        End If

        'contains upper case char?
        If Not Regex.IsMatch(password, "[A-Z]") Then
            passwordScore -= 10
        End If

        'contains special char?
        If Not Regex.IsMatch(password, "[!,@,#,$,%,^,&,*,?,_,~,-,/""]") Then
            passwordScore -= 10
        End If

        'Length more than 4?
        If (password.Length < 5) Then passwordScore -= 10

        passwordScore = Math.Max(passwordScore, 0)

        'get strength rating from array  
        MyBase.Text = If(associatedEditControl.Text.Trim <> "", StrengthRatings(passwordScore \ 10), "")
        'change score property
        score = passwordScore

    End Sub

End Class
